export declare class Handler {
    private input;
    constructor(input: Handler | []);
    readonly value: [] | Handler;
    /**
     * ForEach
     * @param  {any} cb
     * @returns Promise
     */
    forEach(cb: (value: any, index?: number, collection?: any[]) => Promise<void>): Promise<void>;
    /**
     * Map
     * @param  {any} cb
     * @returns Promise<any[]>
     */
    map(cb: (value: any, index?: number, collection?: any[]) => Promise<void>): Promise<Handler>;
    /**
     * filter
     * @param  {any} cb
     * @returns Promise<any[]>
     */
    filter(cb: (value: any, index?: number, collection?: any[]) => Promise<void>): Promise<Handler>;
    /**
     * find
     * @param  {any} cb
     * @returns Promise<any>
     */
    find(cb: (value: any, index?: number, collection?: any[]) => Promise<void>): Promise<any>;
    /**
     * find
     * @param  {any} cb
     * @returns Promise<any>
     */
    reduce(initialValue: any, cb: (value: any, index?: number, collection?: any[]) => Promise<any>): Promise<any>;
    toJSON(): [] | Handler;
    toString(): string;
    /**
     * Check whether the give object is function
     * Source from https://github.com/then/is-promise/blob/master/index.js
     * @param  {any} cb
     * @returns boolean
     */
    private isPromise;
    /**
     * Call polly fills
     * @param  {pfFunctions} pfFunction
     * @param  {any} cb
     * @returns Promise
     */
    private callPf;
}
