"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Ref: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/filter#Polyfill
 * @param thisArgs
 * @param collection
 * @param callback
 */
function filter(thisArgs, collection, callback) {
    return __awaiter(this, void 0, void 0, function* () {
        const len = collection.length;
        const res = new Array(len);
        const t = thisArgs;
        let c = 0;
        let i = -1;
        while (++i !== len) {
            if (i in t) {
                if (yield callback.call(t, t[i], i, t)) {
                    res[c++] = t[i];
                }
            }
        }
        res.length = c;
        return res;
    });
}
exports.filter = filter;
//# sourceMappingURL=filter.js.map