"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/find#Polyfill
 * @param thisArgs
 * @param collection
 * @param callback
 */
function find(thisArgs, collection, predicate) {
    return __awaiter(this, void 0, void 0, function* () {
        const o = Object(collection);
        const len = o.length;
        const thisArg = thisArgs;
        let k = 0;
        while (k < len) {
            const kValue = o[k];
            if (yield predicate.call(thisArg, kValue, k, o)) {
                return kValue;
            }
            k++;
        }
        return undefined;
    });
}
exports.find = find;
//# sourceMappingURL=find.js.map