"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * Ref: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/forEach#Polyfill
 * @param thisArgs
 * @param collection
 * @param callback
 */
function forEach(thisArgs, collection, callback) {
    return __awaiter(this, void 0, void 0, function* () {
        const O = Object(collection);
        const len = collection.length;
        const T = thisArgs;
        let k = 0;
        while (k < len) {
            let kValue;
            if (k in O) {
                kValue = O[k];
                yield callback.apply(T, [kValue, k, O]);
            }
            k++;
        }
    });
}
exports.forEach = forEach;
//# sourceMappingURL=foreach.js.map