"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/reduce#Polyfill
 * @param thisArgs
 * @param collection
 * @param callback
 */
function reduce(thisArgs, collection, initialValue, callback) {
    return __awaiter(this, void 0, void 0, function* () {
        const o = Object(collection);
        const len = o.length || 0;
        let k = 0;
        let value = initialValue;
        while (k < len) {
            if (k in o) {
                value = yield callback(value, o[k], k, o);
            }
            k++;
        }
        return value;
    });
}
exports.reduce = reduce;
//# sourceMappingURL=reduce.js.map